#!/bin/bash


LOCAL_ADDRESS=$(ip route get 8.8.8.8 | awk '{print $NF; exit}')
PUBLIC_ADDRESS=$(dig +short myip.opendns.com @resolver1.opendns.com)


# create folder for workload binaries and results
mkdir /opt/workloads/
mkdir -p /opt/results/YCSB/
mkdir -p /opt/results/TPCC/

sudo apt-get update -y
sudo apt-get install git maven unzip -y

# install java8 headless
apt-get install openjdk-8-jdk-headless -y

# install python-minimal for YCSB cli
apt-get install python-minimal -y

# download and extract YCSB
wget https://github.com/brianfrankcooper/YCSB/releases/download/0.15.0/ycsb-0.15.0.tar.gz -P /opt/workloads/
cd /opt/workloads/
tar -xzf ycsb-0.15.0.tar.gz
# downlaod additional jar libraries for mysql and postgres-sql
cd /opt/workloads/ycsb-0.15.0/jdbc-binding/lib
wget https://jdbc.postgresql.org/download/postgresql-42.2.2.jar
chmod +x postgresql-42.2.2.jar
wget https://dev.mysql.com/get/Downloads/Connector-J/mysql-connector-java-5.1.47.zip
unzip mysql-connector-java-5.1.47.zip
mv mysql-connector-java-5.1.47/mysql-connector-java-5.1.47.jar mysql-connector-java-5.1.47.jar
chmod +x mysql-connector-java-5.1.47.jar
rm mysql-connector-java-5.1.47.zip
#TODO: download fixed jdbc binding from omigitlab




# downlaod cockroachdb loadgen 
mkdir cd /opt/workloads/cockroach-loadgen/
cd /opt/workloads/cockroach-loadgen
wget https://edge-binaries.cockroachdb.com/cockroach/workload.LATEST -O loadgen.sh
chmod +x loadgen.sh

# prepare Swagger UI
sed -i "s/localhost/$PUBLIC_ADDRESS/g" /opt/workload-API/src/main/webapp/index.html
sed -i "s/localhost/$PUBLIC_ADDRESS/g" /opt/workload-API/src/main/webapp/WEB-INF/web.xml


# install telegraf
SCENARIO_ID=evaluation
export SCENARIO_ID
SCENARIO_CONFIGURATION=worload-api
export SCENARIO_CONFIGURATION
SCENARIO_CLOUD=omistack
export SCENARIO_CLOUD
INFLUXDB_URL=TODO
export INFLUXDB_URL
INFLUXDB_DB=telegraf
export INFLUXDB_DB
PRIVATE_IP=$PRIVATE_ADDRESS
export PRIVATE_IP
PUBLIC_IP=$PUBLIC_ADDRESS
export PUBLIC_IP


cd /opt/
wget https://omi-gitlab.e-technik.uni-ulm.de/dbms-jungle-explorer/dbms-catalogue-scripts/raw/master/scripts/monitoring/telegraf/telegraf.sh
chmod +x telegraf.sh
./telegraf.sh

# TODO start service in screen or nohup via mvn:jetty run
