/*
 * Workload API
 * Benchmark your distributed DBMS with a specific workload
 *
 * OpenAPI spec version: 0.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package de.uulm.omi.cloudiator.dbms.evaluator.model;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.math.BigDecimal;
import javax.validation.constraints.*;

/**
 * parameters for the data generation phase
 */
@ApiModel(description = "parameters for the data generation phase")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaJerseyServerCodegen", date = "2020-05-19T16:43:06.028+02:00")
public class TSBSDataGeneration   {
  @JsonProperty("usecase")
  private String usecase = null;

  @JsonProperty("seed")
  private BigDecimal seed = null;

  @JsonProperty("scale")
  private BigDecimal scale = null;

  @JsonProperty("startTime")
  private String startTime = null;

  @JsonProperty("endTime")
  private String endTime = null;

  @JsonProperty("logInterval")
  private String logInterval = null;

  public TSBSDataGeneration usecase(String usecase) {
    this.usecase = usecase;
    return this;
  }

  /**
   * TSBBS supports currently: devops, iot 
   * @return usecase
   **/
  @JsonProperty("usecase")
  @ApiModelProperty(example = "cpu-only", value = "TSBBS supports currently: devops, iot ")
  public String getUsecase() {
    return usecase;
  }

  public void setUsecase(String usecase) {
    this.usecase = usecase;
  }

  public TSBSDataGeneration seed(BigDecimal seed) {
    this.seed = seed;
    return this;
  }

  /**
   * By supplying the same seed to the generation programs, each database is loaded with identical data and queried using identical queries.
   * @return seed
   **/
  @JsonProperty("seed")
  @ApiModelProperty(example = "123.0", value = "By supplying the same seed to the generation programs, each database is loaded with identical data and queried using identical queries.")
  public BigDecimal getSeed() {
    return seed;
  }

  public void setSeed(BigDecimal seed) {
    this.seed = seed;
  }

  public TSBSDataGeneration scale(BigDecimal scale) {
    this.scale = scale;
    return this;
  }

  /**
   * TODO
   * @return scale
   **/
  @JsonProperty("scale")
  @ApiModelProperty(example = "1000.0", value = "TODO")
  public BigDecimal getScale() {
    return scale;
  }

  public void setScale(BigDecimal scale) {
    this.scale = scale;
  }

  public TSBSDataGeneration startTime(String startTime) {
    this.startTime = startTime;
    return this;
  }

  /**
   * starting timestamp for generating the data
   * @return startTime
   **/
  @JsonProperty("startTime")
  @ApiModelProperty(example = "2016-01-01T00:00:00Z", value = "starting timestamp for generating the data")
  public String getStartTime() {
    return startTime;
  }

  public void setStartTime(String startTime) {
    this.startTime = startTime;
  }

  public TSBSDataGeneration endTime(String endTime) {
    this.endTime = endTime;
    return this;
  }

  /**
   * ending timestamp for generating the data
   * @return endTime
   **/
  @JsonProperty("endTime")
  @ApiModelProperty(example = "2016-01-01T01:00:00Z", value = "ending timestamp for generating the data")
  public String getEndTime() {
    return endTime;
  }

  public void setEndTime(String endTime) {
    this.endTime = endTime;
  }

  public TSBSDataGeneration logInterval(String logInterval) {
    this.logInterval = logInterval;
    return this;
  }

  /**
   * TODO
   * @return logInterval
   **/
  @JsonProperty("logInterval")
  @ApiModelProperty(example = "10s", value = "TODO")
  public String getLogInterval() {
    return logInterval;
  }

  public void setLogInterval(String logInterval) {
    this.logInterval = logInterval;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TSBSDataGeneration tsBSDataGeneration = (TSBSDataGeneration) o;
    return Objects.equals(this.usecase, tsBSDataGeneration.usecase) &&
        Objects.equals(this.seed, tsBSDataGeneration.seed) &&
        Objects.equals(this.scale, tsBSDataGeneration.scale) &&
        Objects.equals(this.startTime, tsBSDataGeneration.startTime) &&
        Objects.equals(this.endTime, tsBSDataGeneration.endTime) &&
        Objects.equals(this.logInterval, tsBSDataGeneration.logInterval);
  }

  @Override
  public int hashCode() {
    return Objects.hash(usecase, seed, scale, startTime, endTime, logInterval);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TSBSDataGeneration {\n");
    
    sb.append("    usecase: ").append(toIndentedString(usecase)).append("\n");
    sb.append("    seed: ").append(toIndentedString(seed)).append("\n");
    sb.append("    scale: ").append(toIndentedString(scale)).append("\n");
    sb.append("    startTime: ").append(toIndentedString(startTime)).append("\n");
    sb.append("    endTime: ").append(toIndentedString(endTime)).append("\n");
    sb.append("    logInterval: ").append(toIndentedString(logInterval)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

