/*
 * Workload API
 * Benchmark your distributed DBMS with a specific workload
 *
 * OpenAPI spec version: 0.0.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package de.uulm.omi.cloudiator.dbms.evaluator.model;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import de.uulm.omi.cloudiator.dbms.evaluator.model.TSDBMSDBMSProperties;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.math.BigDecimal;
import javax.validation.constraints.*;

/**
 * TSBSQueryExecution
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaJerseyServerCodegen", date = "2020-05-19T16:43:06.028+02:00")
public class TSBSQueryExecution   {
  @JsonProperty("workers")
  private BigDecimal workers = null;

  @JsonProperty("burnIn")
  private BigDecimal burnIn = null;

  @JsonProperty("debug")
  private Boolean debug = null;

  @JsonProperty("printInterval")
  private BigDecimal printInterval = null;

  @JsonProperty("printResponses")
  private Boolean printResponses = null;

  @JsonProperty("dbmsPorperties")
  private java.util.List<TSDBMSDBMSProperties> dbmsPorperties = null;

  public TSBSQueryExecution workers(BigDecimal workers) {
    this.workers = workers;
    return this;
  }

  /**
   * number of worker to execute the workload
   * @return workers
   **/
  @JsonProperty("workers")
  @ApiModelProperty(example = "4.0", value = "number of worker to execute the workload")
  public BigDecimal getWorkers() {
    return workers;
  }

  public void setWorkers(BigDecimal workers) {
    this.workers = workers;
  }

  public TSBSQueryExecution burnIn(BigDecimal burnIn) {
    this.burnIn = burnIn;
    return this;
  }

  /**
   * number of queries to ignore before collecting statistics
   * @return burnIn
   **/
  @JsonProperty("burnIn")
  @ApiModelProperty(example = "0.0", value = "number of queries to ignore before collecting statistics")
  public BigDecimal getBurnIn() {
    return burnIn;
  }

  public void setBurnIn(BigDecimal burnIn) {
    this.burnIn = burnIn;
  }

  public TSBSQueryExecution debug(Boolean debug) {
    this.debug = debug;
    return this;
  }

  /**
   * print debug messages
   * @return debug
   **/
  @JsonProperty("debug")
  @ApiModelProperty(example = "false", value = "print debug messages")
  public Boolean isDebug() {
    return debug;
  }

  public void setDebug(Boolean debug) {
    this.debug = debug;
  }

  public TSBSQueryExecution printInterval(BigDecimal printInterval) {
    this.printInterval = printInterval;
    return this;
  }

  /**
   * print timing stats to stderr after this many queries (0 to disable) (default 100)
   * @return printInterval
   **/
  @JsonProperty("printInterval")
  @ApiModelProperty(example = "100.0", value = "print timing stats to stderr after this many queries (0 to disable) (default 100)")
  public BigDecimal getPrintInterval() {
    return printInterval;
  }

  public void setPrintInterval(BigDecimal printInterval) {
    this.printInterval = printInterval;
  }

  public TSBSQueryExecution printResponses(Boolean printResponses) {
    this.printResponses = printResponses;
    return this;
  }

  /**
   * pretty print response bodies for correctness checking (default false)
   * @return printResponses
   **/
  @JsonProperty("printResponses")
  @ApiModelProperty(example = "false", value = "pretty print response bodies for correctness checking (default false)")
  public Boolean isPrintResponses() {
    return printResponses;
  }

  public void setPrintResponses(Boolean printResponses) {
    this.printResponses = printResponses;
  }

  public TSBSQueryExecution dbmsPorperties(java.util.List<TSDBMSDBMSProperties> dbmsPorperties) {
    this.dbmsPorperties = dbmsPorperties;
    return this;
  }

  public TSBSQueryExecution addDbmsPorpertiesItem(TSDBMSDBMSProperties dbmsPorpertiesItem) {
    if (this.dbmsPorperties == null) {
      this.dbmsPorperties = new java.util.ArrayList<>();
    }
    this.dbmsPorperties.add(dbmsPorpertiesItem);
    return this;
  }

  /**
   * Get dbmsPorperties
   * @return dbmsPorperties
   **/
  @JsonProperty("dbmsPorperties")
  @ApiModelProperty(value = "")
  public java.util.List<TSDBMSDBMSProperties> getDbmsPorperties() {
    return dbmsPorperties;
  }

  public void setDbmsPorperties(java.util.List<TSDBMSDBMSProperties> dbmsPorperties) {
    this.dbmsPorperties = dbmsPorperties;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TSBSQueryExecution tsBSQueryExecution = (TSBSQueryExecution) o;
    return Objects.equals(this.workers, tsBSQueryExecution.workers) &&
        Objects.equals(this.burnIn, tsBSQueryExecution.burnIn) &&
        Objects.equals(this.debug, tsBSQueryExecution.debug) &&
        Objects.equals(this.printInterval, tsBSQueryExecution.printInterval) &&
        Objects.equals(this.printResponses, tsBSQueryExecution.printResponses) &&
        Objects.equals(this.dbmsPorperties, tsBSQueryExecution.dbmsPorperties);
  }

  @Override
  public int hashCode() {
    return Objects.hash(workers, burnIn, debug, printInterval, printResponses, dbmsPorperties);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TSBSQueryExecution {\n");
    
    sb.append("    workers: ").append(toIndentedString(workers)).append("\n");
    sb.append("    burnIn: ").append(toIndentedString(burnIn)).append("\n");
    sb.append("    debug: ").append(toIndentedString(debug)).append("\n");
    sb.append("    printInterval: ").append(toIndentedString(printInterval)).append("\n");
    sb.append("    printResponses: ").append(toIndentedString(printResponses)).append("\n");
    sb.append("    dbmsPorperties: ").append(toIndentedString(dbmsPorperties)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

