package de.uulm.omi.dbms.workload.api;

import de.uulm.omi.utils.WorkloadApiProperties;
import io.swagger.jaxrs.config.SwaggerContextService;
import io.swagger.models.Contact;
import io.swagger.models.Info;
import io.swagger.models.License;
import io.swagger.models.Swagger;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class Bootstrap extends HttpServlet {



  private  final Logger LOGGER = LoggerFactory.getLogger(this.getClass());


  @Override
  public void init(ServletConfig config) throws ServletException {
    Info info = new Info()
        .title("Workload API")
        .description("Benchmark your distributed DB with a specific workload")
        .termsOfService("")
        .contact(new Contact()
            .email("danie.seybold@uni-ulm.de"))
        .license(new License()
            .name("")
            .url("http://unlicense.org"));

    ServletContext context = config.getServletContext();



    Swagger swagger = new Swagger().info(info);

    LOGGER.debug("init properties...");
    WorkloadApiProperties.getInstance().initProperties(context);

    new SwaggerContextService().withServletConfig(config).updateSwagger(swagger);
  }

}
