package de.uulm.omi.utils;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.concurrent.Callable;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Created by Daniel Seybold on 16.01.2018.
 *
 * Reads from the process output streams and dumps the output to a file
 *
 * Currently not used as process output is written to a file via shell commands when starting the process
 */
public class OutputHandler implements Callable {

  private  final Logger LOGGER = LoggerFactory.getLogger(this.getClass());

  BufferedReader output;

  public OutputHandler(Process process){

    //TODO: merge output and error stream into one stream with SequenceInputStream ?

    output = new BufferedReader(new InputStreamReader(process.getInputStream()));
  }

  @Override
  public Object call() throws Exception {

    String line = "";

    while ((line = output.readLine()) != null) {
      LOGGER.debug(line);
    }

    return "finished!";
  }
}
