package de.uulm.omi.utils;

import static com.google.common.base.Preconditions.checkNotNull;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Properties;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * Created by Daniel Seybold on 27.04.2018.
 */
public class TextFileLoader {

  private  static  final Logger LOGGER = LoggerFactory.getLogger(TextFileLoader.class.getName());

  public static File loadScript(String taskId, String workloadType) throws FileNotFoundException {

    checkNotNull(taskId);
    checkNotNull(workloadType);

    Properties properties = WorkloadApiProperties.getInstance().getProperties();

    String pathToScript = properties.getProperty(WorkloadApiProperties.WORKLOAD_RESULTS_FOLDER)
        + workloadType
        + File.separator
        + taskId
        + ".txt";


    LOGGER.debug("Loading result file from path: " + pathToScript);
    File resultFile = new File(pathToScript);

    try {

      if(resultFile == null) throw new FileNotFoundException("Unable to load result file from: " + pathToScript);
      return resultFile;


    } catch (FileNotFoundException e){

      throw e;

    }

  }
}
